!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	module sfcalb_history
! lstack # of land 10' boxes  roughly 2160*1080*0.33
!! 33% of earth is land ( but map is eq angular not eq area so expect more)
!ivector(mstack) -  to go from 10'map index to packed land subset
!mvector - inverse of ivector - go from packed land subset index to full 10'map index

	parameter(mag=6,nio=3,iunit=10)
	parameter(mstack=360*180*mag*mag)
	parameter( lstack=815246) !! IGBP not 17
	integer,save      :: ivector(mstack)
	integer,save      :: mvector(lstack)
	integer*1,save 	  :: igbpa(lstack)
	integer*2,save    :: icnts(lstack,nio)
	integer*1,save    :: hold(4,lstack,nio) 
	integer*1 bu0
	real,save :: ohsalb(2),u0x(2),dcalc,aohsd,aohsr

	real*4,save ::  dfld(lstack)
!	real*4 ubar(lstack),dcnt(lstack)
	real,save,dimension(20) ::  ddef,specshape,dbba
	character*120,save :: sahfile 
	data sahfile /'sfcalb_history.v4.'/
      

	data ddef/
     *0.40, ! ( 1) EVERGREEN NEEDLE FOR 
     *0.44, ! ( 2) EVERGREEN BROAD FOR 
     *0.32, ! ( 3) DECIDUOUS NEEDLE FOR
     *0.39, ! ( 4) DECIDUOUS BROAD FOR
     *0.22, ! ( 5) MIXED FOREST
     *0.28, ! ( 6) CLOSED SHRUBS
     *0.4,  ! ( 7) OPEN/SHRUBS
     *0.15, ! ( 8) WOODY SAVANNA
     *0.27, ! ( 9) SAVANNA
     *0.22, ! (10) GRASSLAND
     *0.35, ! (11) WETLAND
     *0.24, ! (12) CROPLAND (CAGEX-APR)
     *0.1,  ! (13) URBAN
     *0.12, ! (14) CROP MOSAIC
     *0.1,  ! (15) ANTARCTIC SNOW
     *0.4,  ! (16) BARREN/DESERT
     *0.41, ! (17) OCEAN WATER
     *0.58, ! (18) TUNDRA
     *0.1,  ! (19) FRESH SNOW
     *0.1/  ! (20) SEA ICE

	data specshape / !! ln ( swIR / swVIS)
     &	1.59, 1.59, 1.59, 1.69, 1.78, 0.91, 0.50, 1.54, 1.36, 1.31,
     &  1.82, 1.30, 0.99, 1.31,-0.18, 0.25,-0.55, 0.99,-0.10,-0.36/

       data dbba/0.1188,0.130,0.1188,0.1726,0.1443,0.2175,0.2314,0.1620,
     & 0.1818,0.1841,0.1147,0.1496,0.1697,0.1583,0.8322,0.3551,0.0660,
     & 0.1697,0.8549,0.6116/

	contains 

!------------------------------------------------------------
	subroutine overlay(iio1,iio2)
! IF NO DATA in {iio1 maps} put {iio2 } into {iio1 }

	do is=1,lstack
	if ( icnts(is,iio1) == 0 .and. icnts(is,iio2) > 0 ) then
	  hold(1:4,is,iio1) = hold(1:4,is,iio2)
	  icnts(is,iio1) = icnts(is,iio2)
!	else
!	  hold(1:4,is,iio1) = 0
	endif 


	enddo
	end subroutine overlay
!------------------------------------------------------------
	subroutine difference(iio1,iio2)
! IF BOTH DATA  {iio1} minus {iio2 } 

	dfld=-9999.
!	ubar=-9999.
!	dcnt=-9999.
	do is=1,lstack
	if (  icnts(is,iio1) > 0 
     &  .and. icnts(is,iio2) > 0  
!     &  .and. ( icnts(is,iio1) < 2 .or. icnts(is,iio2) < 2 )
     &  .and. hold(1,is,iio1).ne.0
     &  .and. hold(3,is,iio1).ne.0
     &  .and. hold(1,is,iio2).ne.0
     &  .and. hold(3,is,iio2).ne.0) then
	rcnt = icnts(is,iio1)
	if ( icnts(is,iio2) < icnts(is,iio1) ) rcnt =icnts(is,iio2)
!	dcnt(is)=icnts(is,iio1) - icnts(is,iio2)
	  a1= unpka(hold(1,is,iio1))
	  a2= unpka(hold(1,is,iio2)) 
	  u1= hold(3,is,iio1)*0.01
	  u2= hold(3,is,iio2)*0.01
!	  ubar(is) = (u1+u2)*0.5
         uohs=1.0 ; dd  = ddef(igbpa(is))
	 a1x= dickensonx(a1,dd,u1,uohs)
	 a2x= dickensonx(a2,dd,u2,uohs) 
!!!	if (abs( a1x-a2x ) >0.01 )
	dfld(is) = a1x-a2x
	  
!	print'(10f8.3)', a1,a2,u1,u2 ,a1x,a2x,dfld(is)

	endif
	
	enddo

	return

	end subroutine difference
!------------------------------------------------------------
	subroutine apply_mthdif(iio1,iio2)
! IF NO DATA in {iio1 maps} put {iio2 } into {iio1 }

	do is=1,lstack
	if ( icnts(is,iio1) == 0  .and. icnts(is,iio2) > 0 ) then

        if ( dfld(is).ne.-9999) then
	 if ( hold(1  ,is,iio2) .ne. 0 ) 
     & 	  hold(1  ,is,iio1) = pkalb(unpka(hold(1,is,iio2))+dfld(is))

	 if ( hold(2  ,is,iio2) .ne. 0 ) 
     &	  hold(2  ,is,iio1) = pkalb(unpka(hold(2,is,iio2))+dfld(is))

	  hold(3:4,is,iio1) = hold(3:4,is,iio2)
	  icnts(is,iio1) = icnts(is,iio2)
	else
	  hold(1:4,is,iio1) = hold(1:4,is,iio2)
	  icnts(is,iio1) = icnts(is,iio2)
	endif 

!!	else
!!	 hold(1:4,is,iio1) = 0
	endif


	enddo
	end subroutine apply_mthdif

!------------------------------------------------------------
	subroutine replace(iio1,iio2)
! IF {iio2 maps} have lower albedo values put {iio2 } into {iio1 }
	do is=1,lstack
	ire=0
	if (	icnts(is,iio2 ) == 0 ) cycle
	if ( 
     &   ( unpka(hold(1,is,iio2)) < unpka(hold(1,is,iio1)) )
     &     .and. hold(1,is,iio2).ne.0
     &     .and. hold(3,is,iio2).ne.0) then
	  hold(1,is,iio1) = hold(1,is,iio2)
	  hold(3,is,iio1) = hold(3,is,iio2)
	ire=1
	endif 

	if (  
     & ( unpka(hold(2,is,iio2)) < unpka(hold(2,is,iio1)) )
     &   .and. hold(2,is,iio2).ne.0
     &   .and. hold(4,is,iio2).ne.0)then
	  hold(2,is,iio1) = hold(2,is,iio2)
	  hold(4,is,iio1) = hold(4,is,iio2)
	ire=1
	endif 
	
	 if(ire==1)icnts(is,iio1) = icnts(is,iio1)+icnts(is,iio2)

	enddo

	end subroutine replace
!------------------------------------------------------------
	integer function map_index(rlat,rlon)
	 if ( rlon < 0 ) rlon = rlon + 360.
	 lon10= ifix(rlon*mag)
	 if (  lon10 < 1)    lon10 =1
	 if (  lon10 > 360*mag) lon10 =360*mag

	 lat10= ifix((rlat+90.)*mag)
	 if (  lat10 < 1)    lat10 =1
	 if (  lat10 > 180*mag) lat10 =180*mag
	 map_index = (lat10-1)*360*mag + lon10

	end function map_index
!------------------------------------------------------------
	subroutine  inverse_map_index(imap,rlato,rlono)
	nplat= 360*mag
	ddd= 1./float(mag)

	ilat = 1+ (imap-1)/nplat
	ilon = imap - (ilat-1)*nplat
	rlato= -90 -(ddd*0.5) + ilat * ddd
	rlono=     -(ddd*0.5) + ilon * ddd

	end subroutine inverse_map_index
!------------------------------------------------------------
	subroutine gen_ivector
!!	THIS SUBROUTINE IS ONLY NECESSARY FOR THE ( ONE TIME) creation
!!	OF THE INDEX ARRAYS

        integer*1 igbp(2160,1080)
	
! INPUT FILES	

	open(iunit,file='IGBP.map'
c     & ,form='U',access='direct',recl=mstack,action='read',err=999)
     & ,form='unformatted',access='direct',recl=mstack,
     1   action='read',err=999)
	read(iunit,rec=1,err=999) igbp
	igbp(:,1:1080) = igbp(:,1080:1:-1)
	close(iunit)

	iland=0 ;imap=0
	LATL : do j=1,1080
	LONL : do i=1,2160
	imap=imap+1
	ivector(imap) = 0

	if( igbp(i,j) .ne. 17 ) then  !!! NOT IGBP WATER equals LAND !!!
	 iland=iland+1
	 ivector(imap) = iland
	 igbpa(iland)  = igbp(i,j)
	endif !land
	enddo LONL
	enddo LATL


	do ii=1,mstack ! Create Inverse vector
	kk=ivector(ii)
	if ( kk .ne. 0 ) mvector(kk)= ii
	enddo

	print *,' # of land gridboxes : lstack= ' ,iland
	if ( iland .ne. lstack ) stop ' ERR lstack'

	return

999	stop ' gen_ivector ERROR'
	end subroutine gen_ivector
!------------------------------------------------------------
	subroutine salbhist_io(mode,iyr,imo,iio,ios)
	character*1 mode
	character*4 cyr
	character*2 cmo
	logical,save :: inital
	data inital /.true./
104	format(i4.4)
102	format(i2.2)
	write(cyr,104) iyr
	write(cmo,102) imo
	ios=0


	if ( mode == 'C' ) then 	!! Create
	open(iunit,file=trim(sahfile)//cyr//cmo
     & ,form='unformatted',status='NEW',iostat=ios)

	if ( ios == 0 ) then
	 print *,'Create: ',trim(sahfile)//cyr//cmo
	else
	 print *,'STOP :Preexisting ?: ',trim(sahfile)//cyr//cmo
	 stop 
	endif

	 icnts(1:lstack,iio)=0
	 hold(:,1:lstack,iio)=0
!	 write(iunit) icnts(1:lstack,iio)
!	 write(iunit) hold(:,1:lstack,iio)

	elseif ( mode == 'W' ) then 	!! WRITE
	open(iunit,file=trim(sahfile)//cyr//cmo
     & ,form='unformatted',status='OLD',action='WRITE',iostat=ios)
	print *,'Write: ',trim(sahfile)//cyr//cmo
	 if ( ios .ne. 0 ) return
	 write(iunit) icnts(1:lstack,iio)
	 write(iunit) hold(:,1:lstack,iio)

	elseif ( mode == 'R' ) then 	!! READ
	open(iunit,file=trim(sahfile)//cyr//cmo
     & ,form='unformatted',status='OLD',action='READ',iostat=ios)
	print *,'Read: ',trim(sahfile)//cyr//cmo
	 if ( ios .ne. 0 ) return
	 read(iunit) icnts(1:lstack,iio)
	 read(iunit) hold(:,1:lstack,iio)

	else
	 stop 'bad salbhist_io mode'
	endif

	close(iunit)

	if (inital) then
	 call gen_ivector
	 inital=.false.
	endif

	return
	end subroutine salbhist_io

!--------------------------------------------------------
	integer function iu0_bin(u0)
	 if(u0 > 0.5 .and.u0 <= 1.0  ) iu0_bin=1
	 if(u0 > 0.0 .and.u0 <= 0.5 ) iu0_bin=2
	end function iu0_bin
!------------------------------------------------------------
	real function dvalue(r1,r2,u1,u2)
	dvalue =( r2-r1 )/(2.0*(r1*u1-r2*u2))
	end function dvalue
!------------------------------------------------------------
	real function dickenson(a5,dd,u0)
	dickenson = a5 *(1.0+dd)/(1.0+2.0*dd*u0)
	end function dickenson
!------------------------------------------------------------
	real function dickensonx(a1,dd,u1,u2)
	dickensonx = a1 *(1.0+2.0*dd*u1)/(1.0+2.0*dd*u2)
	end function dickensonx
!---------------------------------------------------------------
!UNPACK --------------------------------------------------------
	real function unpka(bv)!! -128:127 --> 0-1.0
	integer*1 bv
	if ( bv < 0 ) then
	 ibvt =256+bv
	else
	 ibvt=bv 
	endif
	unpka= 1.0 - log(1+ (255-ibvt)* 1.7182818/255.)
	if( unpka < 0.001) unpka=0.0
	return
	end function unpka
!PACK --------------------------
	integer*1 function pkalb(alb)!! 0-1.0 --> 0:255
	real alb
	pkalb=nint(255-(255./1.7182818)*(exp(1.-alb) -1.))
	return
	end function pkalb

!--------------------------------------------------------------------
!----------------------------------------------------------------------------
	subroutine calcbox(is)
	iio=1
	ohsalb = -9999. ; u0x=-9999. ; dcalc=-9999.
	a1 = -9999 ; aohsd=-9999.; aohsr=-9999.
        if ( icnts(is,iio) > 0 )then
	  rcnt=icnts(is,iio)

	  do iu0=1,2 
	     iu2=iu0+2
	   ohsalb(iu0)= unpka( hold(iu0,is,iio) )
	   u0x(iu0)   =        hold(iu2,is,iio)*0.01
	  enddo

	   where(u0x == 0 ) 
	     ohsalb=-9999.
	     u0x   =-9999.
	  endwhere

	  if ( u0x(1)  >0 .and. u0x(2) > 0 .and.
     &        abs(u0x(1)-u0x(2))> 0.2 )
     & 	  dcalc= dvalue(ohsalb(1),ohsalb(2),u0x(1),u0x(2))

	if ( ohsalb(1) >0 .and. u0x(1) > 0 )then
	 a1=ohsalb(1) ; u0=u0x(1)
	elseif ( ohsalb(2) >0 .and. u0x(2) > 0 ) then
	 a1=ohsalb(2) ; u0=u0x(2)
	endif

	if ( a1 >0) then
	 uohs=1.0 ; dd  = ddef(igbpa(is))
	 aohsd= dickensonx(a1,dd,u0,uohs)   !! OVERHEAD SUN ALBEDO USING DEFAULT D
	 aohsr= dickensonx(a1,dcalc,u0,uohs)!! OVERHEAD SUN ALBEDO USING Retrieved D
	endif

	endif ! icnts >0

	return

	end subroutine calcbox

!--------------------------------------------------------------------
	subroutine fred_map_write(cyr,cmo)

	character*4 cyr
	character*2 cmo

	print *,'WRITE: ',trim(sahfile)//'out.'//cyr//cmo
	open (12,file=trim(sahfile)//'out.'//cyr//cmo,
     1         form='unformatted')

	do is=1,lstack

	ii = mvector(is)
	call inverse_map_index(ii,rlat,rlon)

	call calcbox(is)

	rigbp= igbpa(is)
	rcnt = icnts(is,1) 

	  if ( icnts(is,1) > 0 ) write(12) rlat,rlon,
     &   rcnt,ohsalb(1:2),u0x(1:2),
     &   rigbp,dcalc,aohsd,aohsr,aohsd-aohsr,
     &   dfld(is)
!     & ,ubar(is),dcnt(is)

	enddo
	close(12)
	return

	end subroutine fred_map_write
!------------------------------------------------------------
	subroutine use_sfcalb_history(rlat,rlon,u0, icount,sfcalbedo)
	parameter (iio1=1)
	icount = 0 ; sfcalbedo=-9999.

	ii = map_index(rlat,rlon)
	is = ivector(ii)


	if ( is < 1 .or. is > lstack ) then
	 if ( is > lstack) print *,'ERR IS',rlat,rlon,ii,is
	 return
	endif
	  icount = icnts(is,iio1)
          if ( icount <  1 ) return
	
	call calcbox(is)
	uohs=1.0; dd  = ddef(igbpa(is))
	sfcalbedo = dickensonx(aohsd,dd,uohs,u0) 
!! OVERHEAD SUN ALBEDO USING DEFAULT D to 'sfcalbedo @u0'
 
	 return
	
	end  subroutine use_sfcalb_history




!!!!-----------------------------------------------------------------------------
	subroutine overlay_maps(cyr,cmo,cx)

	character*1 cx
	character*4 cyr
	character*2 cmo

104	format(i4.4)
	read(cyr,104) iyr
102	format(i2.2)
	read(cmo,102) imo
!---
	iio1 = 1 !!! CURRENT MONTH
	iio2 = 2 !! Sequential Overlays
	iio3 = 3
	if ( cx >= '1')then
	if ( imo < 1 .or. imo > 12 ) STOP 'not proper file month (1-12)'
	if ( iyr < 1  ) STOP 'not proper file year ( >= 1)'
	 imop=imo-1
	 iyrp=iyr
	  if ( imop < 1) then
	   iyrp=iyr-1 ; imop=imop+12
	  endif	
	endif
!0---
	if ( cx >= '0') then
	print *,'OVERLAY 0 = Current Month >> '
	 call salbhist_io('R',iyr,imo,iio1,ios) ! 0=Current Month
	if ( ios .ne. 0 ) stop ' File does not exist 0=Current Month'
	print *, ' '
	endif
!1---
	if ( cx >= '1')then		! 1=Overlay Previous Month w/previous years monthly difference
	print *, 'OVERLAY 1 = Previous Month w/previous years'//
     1           ' monthly difference >>'
	print *,'   This month last year > '
	call salbhist_io('R',iyr-1 ,imo ,iio2,ios2)  ! This month last year
	print *,'   Last month last year > '
	call salbhist_io('R',iyrp-1,imop,iio3,ios3)  ! Last month last year

	 if ( ios2 == 0 .and. ios3 == 0 )then
	 call difference(iio2,iio3) 
	
	else
	 dfld=-9999.
	if(ios2 .ne. 0 )  print *, ' !!!!NO FILE: ',iyrp-1,imop 
	if(ios3 .ne. 0 )  print *, ' !!!!NO FILE: ',iyr-1,imo
	endif
!---
	print *,'   Last Month > '
	 call salbhist_io('R',iyrp,imop,iio2,ios)   
	  if ( ios == 0 )then
	  call apply_mthdif(iio1,iio2)
	  print *, ' '
	  else
	   print *, ' NO FILE: 1=Overlay Previous Month',iyrp,imop
	  endif 
	endif
!2---
	if ( cx >= '2')then		!! 2=Overlay current month of Previous Year
	print *, 'OVERLAY 2 = This month Last Year >>'
	 call salbhist_io('R',iyr-1,imo,iio2,ios)   
	   if ( ios == 0 )then
	    call overlay (iio1,iio2)
	   print *, ' '
	   else
	    print *, ' NO FILE: 2=Overlay current month of Previous'//
     1               ' Year:',iyr-1,imo
	  endif
	endif
!3---
	if ( cx >= '3')then
	print *,'OVERLAY 3 = Last Year MINIMUN over all months >>'
	 do ix = 0,5
	 call salbhist_io('R',iyr-ix,0,iio2,ios)   !!! 3= Overlay Previous Yearly Minimum
	 if ( ios == 0 ) then
	  call overlay (iio1,iio2)
	  print *, ' '
	  exit
	   else
	  print *, ' NO FILE : 3=Overlay Previous Yearly Minimum:',iyr-ix
	 endif 
	enddo
	endif
!4---
	if ( cx >= '4')then
	print *,'OVERLAY 4 = IGBP Based Default Albedo >>'
	 call salbhist_io('R',0,0,iio2,ios)     !!!! 4= Overlay REFERENCE IGBP
	  if ( ios == 0 )then
	   call overlay (iio1,iio2)
	  print *, ' '
	  else
	   stop ' NO FILE : 4= Overlay REFERENCE IGBP'
	  endif


	endif

	return
	end subroutine overlay_maps
	end module sfcalb_history
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

