	program x
	call spectral_dat_test
	call hu_cox_munk_test
	call sfcalb_history_test
	call test_flsa0300_lut
	stop
	end
!====================================================================
	subroutine spectral_dat_test
	USE SPECTRAL_DAT
	real salb15(15),ems12(12),bbalb !OUT

	do iu0= 1,10,2
	u0=iu0*0.1
	do igbp=1,20
	call land_spec(igbp,u0, salb15,bbalb)
	print'(2I7,f10.4,3x,15f7.3)',igbp,iu0,bbalb,salb15

	call get_emiss(igbp,ems12)
!	print'(15f7.3)',ems12
	enddo;enddo

	return
	end
!==============================================================
	subroutine sfcalb_history_test
	USE SFCALB_HISTORY ,only :overlay_maps, use_sfcalb_history 

	character*1 cx
	character*4 cyr
	character*2 cmo
	cx='0'
	cyr='1998'
	cmo='00'
	 call overlay_maps(cyr,cmo,cx)
	rlat=20.
	rlon=20.
	u0=0.9
	do irlon=0,360,2
	rlon=irlon
	 call use_sfcalb_history(rlat,rlon,u0, icount,sfcalbedo)
	print*,rlat,rlon,icount,sfcalbedo
	enddo
	return
	end
!==============================================================

	subroutine  hu_cox_munk_test
	USE HU_COX_MUNK_OCEAN_ALBEDO ,
     &  ONLY:LOAD_HU_COX_MUNK_OCEAN_ALBEDO,
     &       GET_HU_COX_MUNK_OCEAN_ALBEDO,
     &       OCEAN_FOAM_ALB

	real specalb(15)


!! LOAD LOOKUP TABLE !
	call load_hu_cox_munk_ocean_albedo


	print *,' CosSol TAU WindSpeed     '//
     1       'SpectralAlbedo[ 1:5UV 5:10Vis 10:15NIR]'

	do iw= 0,21,20
	wnds    = iw

	do i=10,100,20
	u0=i*0.01
	print*,' '


	do it= 0,4
	if( it==0) tau=0
	if( it==1) tau=0.05
	if( it==2) tau=0.1
	if( it==3) tau=0.5
	if( it==4) tau=10.0

	do ib=1,15
!! LOOKUP OCEAN SPECTRAL ALBEDO FOR Fu-Liou Band
	specalb(ib)  = get_hu_cox_munk_ocean_albedo(u0,tau,wnds,ib)

	Tair=300 ;Th2o=300  !! Get from MOA
!!! Correct for Ocean Foam 
	specalb(ib)  = ocean_foam_alb(wnds,Tair,Th2o,specalb(ib))

	enddo
	print'(3f6.2,3x,3(1x,5(f3.2,1x)))',u0,tau,wnds,specalb
	enddo
	enddo
	enddo
	return
	end
!--------------------------------------------------------------
	subroutine test_flsa0300_lut
        USE FLSA0300_SURFACE_ALBEDO,
     & ONLY:flsa0300_lut_loader,flsa0300_lut

	implicit none
	real toa,u0,pw,o3,ta,spec, sfc_alb,sfc_alb0,psfc
	integer itoa,ifile,ityp

	toa=0.3         !  TOA ALBEDO (0-1)
        u0=0.9          !  Cosine Solar Zenith (0-1)
        pw=1.01         !  Precipitable Water [cm] (0 - 7)
        o3=509          !  OZONE [cm] (0.200 - 0.500)
        ta=exp(-1.55)   !  tau=0.21  Aerosol Optical Depth (0 - 1)
        spec= 0.5       !  Spectral Shape [ln (swIR/swVIS) ] (-1.0 -1.0)
	ityp =2  	! 1=maritime 2=continental 3 =urban 
        psfc=1013.	! surface pressure

	call flsa0300_lut_loader(1)

	do itoa = 15,30
	
	toa =itoa*.01
	sfc_alb = flsa0300_lut(toa,u0,pw,o3,ta,spec,ityp,psfc)

	print'(f8.3,a4,6f7.2,i5)',sfc_alb,' <--',toa,u0,pw,o3,ta,spec,ityp
	enddo	
	
	return
	end
